## libmpack 1.0.2

=== debian/changelog ===
libmpack (1.0.2-2) unstable; urgency=medium

  * Add test/deps to d/copyright.

 -- James McCoy <jamessan@debian.org>  Sat, 25 Jun 2016 22:42:00 -0400

libmpack (1.0.2-1) unstable; urgency=medium

  * Initial release.

 -- James McCoy <jamessan@debian.org>  Sat, 18 Jun 2016 15:10:06 -0400

## libmpack 1.0.3

=== Makefile ===
# Some parts of this Makefile were taken or adapted from libunibilium:
# https://github.com/mauke/unibilium

config ?= debug
SYSTEM ?= $(shell uname -s)

ifeq ($(SYSTEM),Darwin)
  LIBTOOL ?= glibtool
else
  LIBTOOL ?= libtool
endif

ifneq ($(VERBOSE),1)
  LIBTOOL += --quiet
endif

ifneq "$(strip $(findstring clang,$(CC)))" ""
  # When CC is set to clang-${VERSION}, it is very likely that other llvm
  # tools are installed with the same version suffix, so use it for
  # llvm-symbolizer
  SYMBOLIZER ?= $(shell which $(subst clang,llvm-symbolizer,$(CC)))
endif

SYMBOLIZER ?= /usr/bin/llvm-symbolizer

XCFLAGS += -Wall -Wextra -Wconversion -Wstrict-prototypes -pedantic

ifeq ($(ANSI),1)
  # test helper to validate that the library works when compiled as c90
  # (without native 32-bit integers, for example)
  XCFLAGS += -DFORCE_32BIT_INTS -ansi
else
  XCFLAGS += -std=c99
endif

NAME    := mpack
MAJOR   := 1
MINOR   := 0
PATCH   := 3
VERSION := $(MAJOR).$(MINOR).$(PATCH)

LT_REVISION=0
LT_CURRENT=0
LT_AGE=0

PREFIX  ?= /usr/local
LIBDIR  ?= $(PREFIX)/lib
INCDIR  ?= $(PREFIX)/include
SRCDIR  ?= src
TESTDIR ?= test
BINDIR  ?= build
OUTDIR  ?= $(BINDIR)/$(config)

SRC     := core.c conv.c object.c rpc.c
SRC     := $(addprefix $(SRCDIR)/,$(SRC))
HDRS    := $(SRC:.c=.h)
OBJ     := $(addprefix $(OUTDIR)/,$(SRC:.c=.lo))
LIBRARY := lib$(NAME).la
LIB     := $(OUTDIR)/$(LIBRARY)
TSRC    := $(wildcard $(TESTDIR)/*.c) $(TESTDIR)/deps/tap/tap.c
TOBJ    := $(addprefix $(OUTDIR)/,$(TSRC:.c=.lo))
TEXE    := $(OUTDIR)/run-tests
AMALG   := $(BINDIR)/$(NAME).c
AMALG_H := $(AMALG:.c=.h)
COVOUT  := $(OUTDIR)/gcov.txt
PROFOUT := $(OUTDIR)/gprof.txt

TEST_FILTER_OUT := --coverage -ansi -std=c99

.PHONY: all
all: lib-bin test-bin

include .config/$(config).mk

.PHONY: tools
tools: $(COMPILER) $(RUNNER)

.PHONY: amalgamation
amalgamation: $(AMALG)

.PHONY: lib-bin
lib-bin: tools $(LIB)

.PHONY: test-bin
test-bin: lib-bin $(TEXE)

.PHONY: test
test: test-bin
	@$(RUNNER) $(TEXE)

.PHONY: gdb
gdb: test-bin
	$(LIBTOOL) --mode=execute gdb -x .gdb $(TEXE)

.PHONY: coverage
coverage: tools $(COVOUT)
	cat $(COVOUT)

.PHONY: profile
profile: tools $(PROFOUT)
	cat $(PROFOUT)

.PHONY: compile_commands.json
compile_commands.json:
	rm -f $(BINDIR)/compile_commands.json
	$(MAKE) config=$(config) clean
	bear $(MAKE) config=$(config)
	mv compile_commands.json $(BINDIR)

.PHONY: install
install: install-inc install-lib
	$(LIBTOOL) --mode=finish '$(DESTDIR)$(LIBDIR)'

.PHONY: install-inc
install-inc: $(AMALG_H) mpack.pc.in
	mkdir -p '$(DESTDIR)$(INCDIR)'
	install -m644 $(AMALG_H) '$(DESTDIR)$(INCDIR)'
	mkdir -p '$(DESTDIR)$(LIBDIR)/pkgconfig'
	sed 's,@VERSION@,$(VERSION),;s,@LIBDIR@,$(LIBDIR),;s,@INCDIR@,$(INCDIR),' <mpack.pc.in >'$(DESTDIR)$(LIBDIR)/pkgconfig/mpack.pc'

.PHONY: install-lib
install-lib: $(LIB)
	mkdir -p '$(DESTDIR)$(LIBDIR)'
	$(LIBTOOL) --mode=install cp $(LIB) '$(DESTDIR)$(LIBDIR)/$(LIBRARY)'

.PHONY: clean
clean:
	rm -rf $(BINDIR)/$(config)

$(TOBJ): XCFLAGS := $(filter-out $(TEST_FILTER_OUT),$(XCFLAGS)) \
	-std=gnu99 -Wno-conversion -Wno-unused-parameter

$(COVOUT): $(SRC) $(TSRC)
	find $(OUTDIR) -type f -name '*.gcda' -print0 | xargs -0 rm -f
	$(MAKE) CFLAGS='-DNDEBUG -g --coverage' LDFLAGS=--coverage config=$(config) test
	find $(OUTDIR)/src -type f -name '*.o' -print0 | \
		xargs -0 gcov -lp > $@
	rm *.c.gcov

$(PROFOUT): $(SRC) $(TSRC)
	$(MAKE) CFLAGS=-pg LDFLAGS=-pg config=$(config) test
	gprof $(OUTDIR)/run-tests gmon.out > $@
	rm gmon.out

$(OUTDIR)/%.lo: %.c $(AMALG)
	@echo compile $< =\> $@
	@$(LIBTOOL) --mode=compile --tag=CC $(CC) $(XCFLAGS) $(CFLAGS) -o $@ -c $<

$(LIB): $(OBJ)
	@echo link $^ =\> $@
	@$(LIBTOOL) --mode=link --tag=CC $(CC) $(XLDFLAGS) $(LDFLAGS) \
		-rpath '$(LIBDIR)' \
		-version-info $(LT_CURRENT):$(LT_REVISION):$(LT_AGE) -o $@ $^

$(TEXE): $(LIB) $(TOBJ)
	@echo link $^ =\> $@
	@$(LIBTOOL) --mode=link --tag=CC $(CC) $(XLDFLAGS) $(LDFLAGS) -lm -g -O \
		-o $@ $(LIB) $(TOBJ)

$(AMALG_H): $(HDRS)
	mkdir -p $(BINDIR)
	cat $^ | sed '/^#include "/d' > $@

$(AMALG): $(AMALG_H) $(SRC)
	mkdir -p $(BINDIR)
	cat $^ | sed '/^#include "/d' > $@

=== binding/lua/Makefile ===
# makefile to setup environment for travis and development

# distributors probably want to set this to 'yes' for both make and make install
USE_SYSTEM_LUA ?= no

# Lua-related configuration
LUA_VERSION_MAJ_MIN ?= 5.1
LUA_VERSION ?= $(LUA_VERSION_MAJ_MIN).5
LUA_VERSION_NOPATCH = $(shell echo -n $(LUA_VERSION) | sed 's!\([0-9]\.[0-9]\).[0-9]!\1!')
LUA_URL ?= https://github.com/lua/lua/releases/download/$(LUA_VERSION)/lua-$(LUA_VERSION).tar.gz
LUAROCKS_URL ?= https://github.com/keplerproject/luarocks/archive/v2.2.0.tar.gz
LUA_TARGET ?= linux

# deps location
DEPS_DIR ?= $(shell pwd)/.deps/$(LUA_VERSION)
DEPS_PREFIX ?= $(DEPS_DIR)/usr
DEPS_BIN ?= $(DEPS_PREFIX)/bin

# targets
LUA ?= $(DEPS_BIN)/lua
LUAROCKS ?= $(DEPS_BIN)/luarocks
BUSTED ?= $(DEPS_BIN)/busted
ifeq ($(USE_SYSTEM_LUA),no)
MPACK ?= $(DEPS_PREFIX)/lib/lua/$(LUA_VERSION_NOPATCH)/mpack.so
else
MPACK ?= mpack.so
endif

# Compilation
CC ?= gcc
PKG_CONFIG ?= pkg-config
CFLAGS ?= -ansi -O0 -g3 -Wall -Wextra -Werror -Wconversion \
	-Wstrict-prototypes -Wno-unused-parameter -pedantic
CFLAGS += -fPIC -DMPACK_DEBUG_REGISTRY_LEAK

LUA_INCLUDE := $(shell $(PKG_CONFIG) --cflags lua-$(LUA_VERSION_MAJ_MIN) 2>/dev/null || echo "-I/usr/include/lua$(LUA_VERSION_MAJ_MIN)")
LUA_LIB := $(shell $(PKG_CONFIG) --libs lua-$(LUA_VERSION_MAJ_MIN) 2>/dev/null || echo "-llua$(LUA_VERSION_MAJ_MIN)")
INCLUDES = $(LUA_INCLUDE)
LIBS = $(LUA_LIB)

LUA_CMOD_INSTALLDIR := $(shell $(PKG_CONFIG) --variable=INSTALL_CMOD lua-$(LUA_VERSION_MAJ_MIN) 2>/dev/null || echo "/usr/lib/lua/$(LUA_VERSION_MAJ_MIN)")


# Misc
# Options used by the 'valgrind' target, which runs the tests under valgrind
VALGRIND_OPTS ?= --error-exitcode=1 --log-file=valgrind.log --leak-check=yes \
	--track-origins=yes
# Command that will download a file and pipe it's contents to stdout
FETCH ?= curl -L -o -
# Command that will gunzip/untar a file from stdin to the current directory,
# stripping one directory component
UNTGZ ?= tar xfz - --strip-components=1


all: $(MPACK)

depsclean:
	rm -rf $(DEPS_DIR)

test: $(BUSTED) $(MPACK)
	$(BUSTED) -o gtest test.lua

valgrind: $(BUSTED) $(MPACK)
	eval $$($(LUAROCKS) path); \
	valgrind $(VALGRIND_OPTS) $(LUA) \
		$(DEPS_PREFIX)/lib/luarocks/rocks/busted/2.0.rc12-1/bin/busted test.lua

gdb: $(BUSTED) $(MPACK)
	eval $$($(LUAROCKS) path); \
	gdb -x .gdb --args $(LUA) \
		$(DEPS_PREFIX)/lib/luarocks/rocks/busted/2.0.rc12-1/bin/busted test.lua

ifeq ($(USE_SYSTEM_LUA),no)
$(MPACK): $(LUAROCKS) lmpack.c
	$(LUAROCKS) make CFLAGS='$(CFLAGS)'
else
$(MPACK): lmpack.c
	$(CC) -shared $(CFLAGS) $(INCLUDES) $(LDFLAGS) $^ -o $@ $(LIBS)
endif

$(BUSTED): $(LUAROCKS)
	$(LUAROCKS) install penlight 1.3.2-2
	$(LUAROCKS) install lua-term 0.7-1
	$(LUAROCKS) install dkjson 2.5-2
	$(LUAROCKS) install lua_cliargs 3.0-1
	$(LUAROCKS) install say 1.3-1
	$(LUAROCKS) install luafilesystem 1.6.3-2
	$(LUAROCKS) install luassert 1.7.10-0
	$(LUAROCKS) install mediator_lua 1.1.2-0
	$(LUAROCKS) install luasystem 0.2.0-0
	$(LUAROCKS) install busted 2.0.rc12-1
	$(LUAROCKS) install inspect  # helpful for debugging

$(LUAROCKS): $(LUA)
	dir="$(DEPS_DIR)/src/luarocks"; \
	mkdir -p $$dir && cd $$dir && \
	$(FETCH) $(LUAROCKS_URL) | $(UNTGZ) && \
	./configure --prefix=$(DEPS_PREFIX) --force-config \
		--with-lua=$(DEPS_PREFIX) && make bootstrap

$(LUA):
	dir="$(DEPS_DIR)/src/lua"; \
	mkdir -p $$dir && cd $$dir && \
	$(FETCH) $(LUA_URL) | $(UNTGZ) && \
	sed -i -e '/^CFLAGS/s/-O2/-g3/' src/Makefile && \
	make $(LUA_TARGET) install INSTALL_TOP=$(DEPS_PREFIX)

install: $(MPACK)
ifeq ($(USE_SYSTEM_LUA),no)
	@:
else
	mkdir -p "$(DESTDIR)$(LUA_CMOD_INSTALLDIR)"
	install -Dm755 $< "$(DESTDIR)$(LUA_CMOD_INSTALLDIR)/$<"
endif

.PHONY: all depsclean install test gdb valgrind

=== debian/changelog ===
libmpack (1.0.3-1) unstable; urgency=medium

  * New upstream release
    + Drop all backported patches.

 -- James McCoy <jamessan@debian.org>  Fri, 16 Dec 2016 21:16:46 -0500

=== debian/control ===
Source: libmpack
Section: libs
Priority: extra
Maintainer: James McCoy <jamessan@debian.org>
Build-Depends: debhelper (>= 9),
               dh-lua,
               libtool-bin,
Standards-Version: 3.9.8
Homepage: https://github.com/tarruda/libmpack/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/libmpack.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libmpack.git

Package: libmpack-dev
Section: libdevel
Architecture: any
Depends: libmpack0 (= ${binary:Version}), ${misc:Depends}
Description: small binary serialization/RPC library (development files)
 libmpack is a small binary serialization/RPC library that implements both the
 msgpack and msgpack-rpc specifications.
 .
 Differences from mspack-c:
 .
  * Callback-based API to simplify (de)serialization directly to/from
    application-specific objects.
  * C89 compatible code
  * No allocation performed by the library, but helpers to simplify dynamic
    allocation if the application needs it.
  * Non-backtracking, incremental/iterative parse/serialization API
 .
 This package contains the headers files needed for developing with mpack

Package: libmpack0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: small binary serialization/RPC library
 libmpack is a small binary serialization/RPC library that implements both the
 msgpack and msgpack-rpc specifications.
 .
 Differences from mspack-c:
 .
  * Callback-based API to simplify (de)serialization directly to/from
    application-specific objects.
  * C89 compatible code
  * No allocation performed by the library, but helpers to simplify dynamic
    allocation if the application needs it.
  * Non-backtracking, incremental/iterative parse/serialization API

Package: lua-mpack
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: ${lua:Provides}
XB-Lua-Versions: ${lua:Versions}
Description: small binary serialization/RPC library (lua bindings)
 libmpack is a small binary serialization/RPC library that implements both the
 msgpack and msgpack-rpc specifications.
 .
 This package provides the Lua bindings based on libmpack.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk

export CFLAGS CPPFLAGS LDFLAGS

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	CONFIG = debug
else
	CONFIG = release
endif

ARGS = config=$(CONFIG) VERBOSE=1 PREFIX=/usr LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)

%:
	dh $@ --with lua --buildsystem=lua --parallel

override_dh_auto_build-arch:
	$(MAKE) $(ARGS)
	dh_auto_build --buildsystem=lua -plua-mpack

override_dh_auto_install-arch:
	$(MAKE) $(ARGS) DESTDIR=$(CURDIR)/debian/tmp install
	dh_auto_install --buildsystem=lua -plua-mpack

override_dh_auto_test:
	$(MAKE) VERBOSE=1 test
# Need busted packaged to run tests for Lua module

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libmpack-$1.tar.gz%" \
    https://github.com/tarruda/libmpack/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## libmpack 1.0.5

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
   # When CC is set to clang-${VERSION}, it is very likely that other llvm
   # tools are installed with the same version suffix, so use it for
   # llvm-symbolizer
-  SYMBOLIZER ?= $(shell which $(subst clang,llvm-symbolizer,$(CC)))
+  SYMBOLIZER ?= $(shell realpath $$(which $(subst clang,llvm-symbolizer,$(CC))))
 endif
 
 SYMBOLIZER ?= /usr/bin/llvm-symbolizer
@@ -73,7 +73,7 @@
 include .config/$(config).mk
 
 .PHONY: tools
-tools: $(COMPILER) $(RUNNER)
+tools: $(C_COMPILER) $(RUNNER)
 
 .PHONY: amalgamation
 amalgamation: $(AMALG)

=== debian/changelog ===
libmpack (1.0.5-2) unstable; urgency=medium

  * Upload to unstable

 -- James McCoy <jamessan@debian.org>  Sat, 22 Jul 2017 21:49:43 -0400

libmpack (1.0.5-1) experimental; urgency=medium

  * New upstream release
    + Update URLs for move to https://github.com/libmpack/libmpack/
  * Remove everything lua, since that has been separated into a distinct
    project.

 -- James McCoy <jamessan@debian.org>  Sun, 30 Apr 2017 15:17:04 -0400

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,9 @@
 Priority: extra
 Maintainer: James McCoy <jamessan@debian.org>
 Build-Depends: debhelper (>= 9),
-               dh-lua,
                libtool-bin,
 Standards-Version: 3.9.8
-Homepage: https://github.com/tarruda/libmpack/
+Homepage: https://github.com/libmpack/libmpack/
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/libmpack.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libmpack.git
 
@@ -46,16 +45,3 @@
   * No allocation performed by the library, but helpers to simplify dynamic
     allocation if the application needs it.
   * Non-backtracking, incremental/iterative parse/serialization API
-
-Package: lua-mpack
-Architecture: any
-Pre-Depends: ${misc:Pre-Depends}
-Multi-Arch: same
-Depends: ${misc:Depends}, ${shlibs:Depends}
-Provides: ${lua:Provides}
-XB-Lua-Versions: ${lua:Versions}
-Description: small binary serialization/RPC library (lua bindings)
- libmpack is a small binary serialization/RPC library that implements both the
- msgpack and msgpack-rpc specifications.
- .
- This package provides the Lua bindings based on libmpack.

=== debian/rules ===
--- 
+++ 
@@ -16,16 +16,13 @@
 ARGS = config=$(CONFIG) VERBOSE=1 PREFIX=/usr LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
 
 %:
-	dh $@ --with lua --buildsystem=lua --parallel
+	dh $@ --parallel
 
 override_dh_auto_build-arch:
 	$(MAKE) $(ARGS)
-	dh_auto_build --buildsystem=lua -plua-mpack
 
 override_dh_auto_install-arch:
 	$(MAKE) $(ARGS) DESTDIR=$(CURDIR)/debian/tmp install
-	dh_auto_install --buildsystem=lua -plua-mpack
 
 override_dh_auto_test:
 	$(MAKE) VERBOSE=1 test
-# Need busted packaged to run tests for Lua module

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libmpack-$1.tar.gz%" \
    https://github.com/libmpack/libmpack/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
